Queries to find minimum sum of array elements from either end of an array
Last Updated :
01 Sep, 2021
Given an array arr[] consisting of N distinct integers and an array queries[] consisting of Q queries, the task is for each query is to find queries[i] in the array and calculate the minimum of sum of array elements from the start and end of the array up to queries[i].
Examples:
Input: arr[] = {2, 3, 6, 7, 4, 5, 30}, Q = 2, queries[] = {6, 5}
Output: 11 27
Explanation:
Query 1: Sum from start = 2 + 3 + 6 = 11. Sum from end = 30 + 5 + 4 + 7 + 6 = 52. Therefore, 11 is the required answer.
Query 2: Sum from start = 27. Sum from end = 35. Therefore, 27 is the required answer.
Input: arr[] = {1, 2, -3, 4}, Q = 2, queries[] = {4, 2}
Output: 4 2
Naive Approach: The simplest approach is to traverse the array upto queries[i] for each query and calculate sum from the end as well as from the start of the array. Finally, print the minimum of the sums obtained.
Below is the implementation of the above approach:
C++
// C++ implementation
// of the above approach
#include <bits/stdc++.h>
using namespace std;
// Function to calculate the minimum
// sum from either end of the arrays
// for the given queries
void calculateQuery(int arr[], int N,
int query[], int M)
{
// Traverse the query[] array
for (int i = 0; i < M; i++) {
int X = query[i];
// Stores sum from start
// and end of the array
int sum_start = 0, sum_end = 0;
// Calculate distance from start
for (int j = 0; j < N; j++) {
sum_start += arr[j];
if (arr[j] == X)
break;
}
// Calculate distance from end
for (int j = N - 1; j >= 0; j--) {
sum_end += arr[j];
if (arr[j] == X)
break;
}
cout << min(sum_end, sum_start) << " ";
}
}
// Driver Code
int main()
{
int arr[] = { 2, 3, 6, 7, 4, 5, 30 };
int queries[] = { 6, 5 };
int N = sizeof(arr) / sizeof(arr[0]);
int M = sizeof(queries)
/ sizeof(queries[0]);
calculateQuery(arr, N, queries, M);
return 0;
}
Java
// Java implementation of the
// above approach
import java.util.*;
import java.lang.*;
public class GFG
{
// Function to calculate the minimum
// sum from either end of the arrays
// for the given queries
static void calculateQuery(int arr[], int N,
int query[], int M)
{
// Traverse the query[] array
for (int i = 0; i < M; i++)
{
int X = query[i];
// Stores sum from start
// and end of the array
int sum_start = 0, sum_end = 0;
// Calculate distance from start
for (int j = 0; j < N; j++)
{
sum_start += arr[j];
if (arr[j] == X)
break;
}
// Calculate distance from end
for (int j = N - 1; j >= 0; j--)
{
sum_end += arr[j];
if (arr[j] == X)
break;
}
System.out.print(Math.min(sum_end, sum_start) + " ");
}
}
// Driver Code
public static void main (String[] args)
{
int arr[] = { 2, 3, 6, 7, 4, 5, 30 };
int queries[] = { 6, 5 };
int N = arr.length;
int M = queries.length;
calculateQuery(arr, N, queries, M);
}
}
// This code is contributed by jana_sayantan.
Python3
# Python 3 implementation
# of the above approach
# Function to calculate the minimum
# sum from either end of the arrays
# for the given queries
def calculateQuery(arr, N, query, M):
# Traverse the query[] array
for i in range(M):
X = query[i]
# Stores sum from start
# and end of the array
sum_start = 0
sum_end = 0
# Calculate distance from start
for j in range(N):
sum_start += arr[j]
if (arr[j] == X):
break
# Calculate distance from end
for j in range(N - 1, -1, -1):
sum_end += arr[j]
if (arr[j] == X):
break
print(min(sum_end, sum_start), end=" ")
# Driver Code
if __name__ == "__main__":
arr = [2, 3, 6, 7, 4, 5, 30]
queries = [6, 5]
N = len(arr)
M = len(queries)
calculateQuery(arr, N, queries, M)
# This code is contributed by chitranayal.
C#
// C# implementation
// of the above approach
using System;
class GFG {
// Function to calculate the minimum
// sum from either end of the arrays
// for the given queries
static void calculateQuery(int[] arr, int N,
int[] query, int M)
{
// Traverse the query[] array
for (int i = 0; i < M; i++) {
int X = query[i];
// Stores sum from start
// and end of the array
int sum_start = 0, sum_end = 0;
// Calculate distance from start
for (int j = 0; j < N; j++) {
sum_start += arr[j];
if (arr[j] == X)
break;
}
// Calculate distance from end
for (int j = N - 1; j >= 0; j--) {
sum_end += arr[j];
if (arr[j] == X)
break;
}
Console.Write(Math.Min(sum_end, sum_start) + " ");
}
}
// Driver code
static void Main()
{
int[] arr = { 2, 3, 6, 7, 4, 5, 30 };
int[] queries = { 6, 5 };
int N = arr.Length;
int M = queries.Length;
calculateQuery(arr, N, queries, M);
}
}
// This code is contributed by divyesh072019.
JavaScript
<script>
// Javascript implementation of the above approach
// Function to calculate the minimum
// sum from either end of the arrays
// for the given queries
function calculateQuery(arr, N, query, M)
{
// Traverse the query[] array
for(let i = 0; i < M; i++)
{
let X = query[i];
// Stores sum from start
// and end of the array
let sum_start = 0, sum_end = 0;
// Calculate distance from start
for(let j = 0; j < N; j++)
{
sum_start += arr[j];
if (arr[j] == X)
break;
}
// Calculate distance from end
for(let j = N - 1; j >= 0; j--)
{
sum_end += arr[j];
if (arr[j] == X)
break;
}
document.write(Math.min(
sum_end, sum_start) + " ");
}
}
// Driver code
let arr = [ 2, 3, 6, 7, 4, 5, 30 ];
let queries = [ 6, 5 ];
let N = arr.length;
let M = queries.length;
calculateQuery(arr, N, queries, M);
// This code is contributed by suresh07
</script>
Time Complexity: O(Q * N)
Auxiliary Space: O(1)
Efficient Approach: The above approach can be optimized by using extra space and the concept of prefix sum and suffix sum and to answer each query in constant computational complexity. The idea is to preprocess prefix and suffix sums for each index. Follow the steps below to solve the problem:
- Initialize two variables, say prefix and suffix.
- Initialize an Unordered Map, say mp, to map array elements as keys to pairs in which the first value gives the prefix sum and the second value gives the suffix sum.
- Traverse the array and keep adding arr[i] to prefix and store it in the map with arr[i] as key and prefix as value.
- Traverse the array in reverse and keep adding arr[i] to suffix and store in the map with arr[i] as key and suffix as value.
- Now traverse the array queries[] and for each query queries[i], print the value of the minimum of mp[queries[i]].first and mp[queries[i]].second as the result.
Below is the implementation of the above approach:
C++
// C++ implementation
// of the above approach
#include <bits/stdc++.h>
using namespace std;
// Function to find the minimum sum
// for the given queries
void calculateQuery(int arr[], int N,
int query[], int M)
{
// Stores prefix and suffix sums
int prefix = 0, suffix = 0;
// Stores pairs of prefix and suffix sums
unordered_map<int, pair<int, int> > mp;
// Traverse the array
for (int i = 0; i < N; i++) {
// Add element to prefix
prefix += arr[i];
// Store prefix for each element
mp[arr[i]].first = prefix;
}
// Traverse the array in reverse
for (int i = N - 1; i >= 0; i--) {
// Add element to suffix
suffix += arr[i];
// Storing suffix for each element
mp[arr[i]].second = suffix;
}
// Traverse the array queries[]
for (int i = 0; i < M; i++) {
int X = query[i];
// Minimum of suffix
// and prefix sums
cout << min(mp[X].first,
mp[X].second)
<< " ";
}
}
// Driver Code
int main()
{
int arr[] = { 2, 3, 6, 7, 4, 5, 30 };
int queries[] = { 6, 5 };
int N = sizeof(arr) / sizeof(arr[0]);
int M = sizeof(queries) / sizeof(queries[0]);
calculateQuery(arr, N, queries, M);
return 0;
}
Java
// Java implementation
// of the above approach
import java.util.*;
class GFG
{
static class pair<E,P>
{
E first;
P second;
public pair(E first, P second)
{
this.first = first;
this.second = second;
}
}
// Function to find the minimum sum
// for the given queries
@SuppressWarnings({ "unchecked", "rawtypes" })
static void calculateQuery(int arr[], int N,
int query[], int M)
{
// Stores prefix and suffix sums
int prefix = 0, suffix = 0;
// Stores pairs of prefix and suffix sums
HashMap<Integer, pair > mp = new HashMap<>();
// Traverse the array
for (int i = 0; i < N; i++) {
// Add element to prefix
prefix += arr[i];
// Store prefix for each element
mp.put(arr[i], new pair(prefix,0));
}
// Traverse the array in reverse
for (int i = N - 1; i >= 0; i--) {
// Add element to suffix
suffix += arr[i];
// Storing suffix for each element
mp.put(arr[i], new pair(mp.get(arr[i]).first,suffix));
}
// Traverse the array queries[]
for (int i = 0; i < M; i++) {
int X = query[i];
// Minimum of suffix
// and prefix sums
System.out.print(Math.min((int)mp.get(X).first,
(int)mp.get(X).second)
+ " ");
}
}
// Driver Code
public static void main(String[] args)
{
int arr[] = { 2, 3, 6, 7, 4, 5, 30 };
int queries[] = { 6, 5 };
int N = arr.length;
int M = queries.length;
calculateQuery(arr, N, queries, M);
}
}
// This code is contributed by 29AjayKumar
Python3
# Python3 implementation
# of the above approach
# Function to find the minimum sum
# for the given queries
def calculateQuery(arr, N, query, M):
# Stores prefix and suffix sums
prefix = 0
suffix = 0
# Stores pairs of prefix and suffix sums
mp = {}
# Traverse the array
for i in range(N):
# Add element to prefix
prefix += arr[i]
# Store prefix for each element
mp[arr[i]] = [prefix, 0]
# Traverse the array in reverse
for i in range(N - 1, -1, -1):
# Add element to suffix
suffix += arr[i]
# Storing suffix for each element
mp[arr[i]] = [mp[arr[i]][0], suffix]
# Traverse the array queries[]
for i in range(M):
X = query[i]
# Minimum of suffix
# and prefix sums
print(min(mp[X][0], mp[X][1]), end = " ")
# Driver Code
arr = [ 2, 3, 6, 7, 4, 5, 30 ]
queries = [ 6, 5 ]
N = len(arr)
M = len(queries)
calculateQuery(arr, N, queries, M)
# This code is contributed by avanitrachhadiya2155
C#
// C# implementation
// of the above approach
using System;
using System.Collections.Generic;
class GFG {
// Function to find the minimum sum
// for the given queries
static void calculateQuery(int[] arr, int N,
int[] query, int M)
{
// Stores prefix and suffix sums
int prefix = 0, suffix = 0;
// Stores pairs of prefix and suffix sums
Dictionary<int, Tuple<int,int>> mp =
new Dictionary<int, Tuple<int,int>>();
// Traverse the array
for (int i = 0; i < N; i++)
{
// Add element to prefix
prefix += arr[i];
// Store prefix for each element
mp[arr[i]] = new Tuple<int,int>(prefix, 0);
}
// Traverse the array in reverse
for (int i = N - 1; i >= 0; i--)
{
// Add element to suffix
suffix += arr[i];
// Storing suffix for each element
mp[arr[i]] = new Tuple<int,int>(mp[arr[i]].Item1, suffix);
}
// Traverse the array queries[]
for (int i = 0; i < M; i++)
{
int X = query[i];
// Minimum of suffix
// and prefix sums
Console.Write(Math.Min(mp[X].Item1, mp[X].Item2) + " ");
}
}
// Driver code
static void Main() {
int[] arr = { 2, 3, 6, 7, 4, 5, 30 };
int[] queries = { 6, 5 };
int N = arr.Length;
int M = queries.Length;
calculateQuery(arr, N, queries, M);
}
}
// This code is contributed by divyeshrabadiya07.
JavaScript
<script>
// Javascript implementation
// of the above approach
// Function to find the minimum sum
// for the given queries
function calculateQuery(arr, N, query, M)
{
// Stores prefix and suffix sums
var prefix = 0, suffix = 0;
// Stores pairs of prefix and suffix sums
var mp = new Map();
// Traverse the array
for(var i = 0; i < N; i++)
{
// Add element to prefix
prefix += arr[i];
// Store prefix for each element
if (!mp.has(arr[i]))
{
mp.set(arr[i], [0, 0]);
}
var tmp = mp.get(arr[i]);
tmp[0] = prefix;
mp.set(arr[i], tmp);
}
// Traverse the array in reverse
for(var i = N - 1; i >= 0; i--)
{
// Add element to suffix
suffix += arr[i];
// Storing suffix for each element
if (!mp.has(arr[i]))
{
mp.set(arr[i], [0, 0]);
}
var tmp = mp.get(arr[i]);
tmp[1] = suffix;
mp.set(arr[i], tmp);
}
// Traverse the array queries[]
for(var i = 0; i < M; i++)
{
var X = query[i];
var tmp = mp.get(X);
// Minimum of suffix
// and prefix sums
document.write(Math.min(tmp[0], tmp[1]) + " ");
}
}
// Driver Code
var arr = [ 2, 3, 6, 7, 4, 5, 30 ];
var queries = [ 6, 5 ];
var N = arr.length;
var M = queries.length;
calculateQuery(arr, N, queries, M);
// This code is contributed by rutvik_56
</script>
Time Complexity: O(M + N)
Auxiliary Space: O(N)
Similar Reads
Queries to find the minimum array sum possible by removing elements from either end
Given an array arr[] consisting of N distinct integers and an array Q[] representing queries, the task for every query Q[i] is to find the minimum sum possible by removing the array elements from either end until Q[i] is obtained. Examples: Input: arr[] = {2, 3, 6, 7, 4, 5, 1}, Q[] = {7, 6}Output: 1
12 min read
Minimum removal of elements from end of an array required to obtain sum K
Given an integer K and an array A[] of size N, the task is to create a new array with sum K with minimum number of operations, where in each operation, an element can be removed either from the start or end of A[] and appended to the new array. If it is not possible to generate a new array with sum
15+ min read
Minimum sum of values subtracted from array elements to make all array elements equal
Given an array arr[] consisting of N positive integers, the task is to find the sum of all the array elements required to be subtracted from each array element such that remaining array elements are all equal. Examples: Input: arr[] = {1, 2}Output: 1Explanation: Subtracting 1 from arr[1] modifies ar
4 min read
Minimum array elements required to be subtracted from either end to reduce K to 0
Given an array arr[] consisting of N integers and an integer K, the task is to reduce K to 0 by removing an array element from either end of the array and subtracting it from K. If it is impossible to reduce K to 0, then print "-1". Otherwise, print the minimum number of such operations required. Ex
9 min read
Remove minimum elements from ends of array so that sum decreases by at least K | O(N)
Given an array arr[] consisting of N elements, the task is to remove minimum number of elements from the ends of the array such that the total sum of the array decreases by at least K. Note that K will always be less than or equal to the sum of all the elements of the array. Examples: Input: arr[] =
7 min read
Find an element in array such that sum of left array is equal to sum of right array
Given, an array of size n. Find an element that divides the array into two sub-arrays with equal sums. Examples: Input: 1 4 2 5 0Output: 2Explanation: If 2 is the partition, subarrays are : [1, 4] and [5] Input: 2 3 4 1 4 5Output: 1Explanation: If 1 is the partition, Subarrays are : [2, 3, 4] and [4
15+ min read
Minimum number of array elements from either ends required to be subtracted from X to reduce X to 0
Given an array nums[] and an integer X, the task is to reduce X to 0 by removing either the leftmost or the rightmost array elements and subtracting its value from X, minimum number of times. If it's possible to reduce X to 0, print the count of operations required. Otherwise, return -1. Examples: I
9 min read
Minimize cost of choosing and skipping array elements to reach end of the given array
Given an integer X and an array cost[] consisting of N integers, the task is to find the minimum cost to reach the end of the given array starting from the first element based on the following constraints: Cost to visit point i is cost[i] where 1 ? i ? N.Cost to skip point i is min(cost[i], X) where
14 min read
Find the minimum and maximum sum of N-1 elements of the array
Given an unsorted array A of size N, the task is to find the minimum and maximum values that can be calculated by adding exactly N-1 elements. Examples: Input: a[] = {13, 5, 11, 9, 7} Output: 32 40 Explanation: Minimum sum is 5 + 7 + 9 + 11 = 32 and maximum sum is 7 + 9 + 11 + 13 = 40.Input: a[] = {
10 min read
Minimum increments or decrements required to signs of prefix sum array elements alternating
Given an array arr[] of N integers, the task is to find the minimum number of increments/decrements of array elements by 1 to make the sign of prefix sum of array alternating. Examples: Input: arr[] = {1, -3, 1, 0}Output: 4Explanation:Following are the operations performed on the given array element
8 min read